UltimasMedicionesPresenter

com.uva.rafael.tfg_goniometer.presenter

## Class UltimasMedicionesPresenter

- java.lang.Object
- - com.uva.rafael.tfg_goniometer.presenter.UltimasMedicionesPresenter

- All Implemented Interfaces:
    PresenterFunctions, PresenterFunctions.UltimasMedicionesFunctions

      public class UltimasMedicionesPresenter
      extends java.lang.Object
      implements PresenterFunctions, PresenterFunctions.UltimasMedicionesFunctions

  Este es el Presentador asociado al `Fragment UltimasMedicionesFragment` de la aplicacion. Se encarga de llevar a cabo toda la logica asociada a las acciones del usuario realizadas en la IU.

  En concreto, se encarga de realizar la "configuracion inicial" del `Fragment`, que, consiste en actualizar el item del `NavigationView` al tercer item del mismo, fijar la orientacion de la pantalla a "Portrait", para evitar que se pueda girar y fijar el `Toolbar` como `SupportActionBar`.

  Ademas de eso, se encarga de configurar el `RecyclerView` inicial que se emplea para mostrar el listado de las ultimas 10 mediciones almacenadas en la Base de Datos(obteniendo el `RecyclerView.Adapter`).

  Por ultimo, se encarga de obtener el `RecyclerView.Adapter` actualizado cada vez que se borra una de las mediciones de la Base de Datos.

  Esta clase forma parte de la aplicacion TFG-Goniometer, desarrollada para el Trabajo de Fin de Grado - Grado en Ingenieria Informatica (Universidad de Valladolid)

  Version:
    1.0
  Author:
    Rafael Matamoros Luque
  See Also:
    `UltimasMedicionesFragment`, `MainModel`, `Toolbar`, `AlertDialog`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.uva.rafael.tfg_goniometer.interfaces.PresenterFunctions

      `PresenterFunctions.HomeFunctions, PresenterFunctions.MainFunctions, PresenterFunctions.MedicionFunctions, PresenterFunctions.NuevaMedicionFunctions, PresenterFunctions.NuevoPacienteFunctions, PresenterFunctions.PacientesFunctions, PresenterFunctions.PerfilPacienteFunctions, PresenterFunctions.SobreAppFunctions, PresenterFunctions.UltimasMedicionesFunctions`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `UltimasMedicionesPresenter(android.app.Fragment fragment, MainModel model)` Constructor principal de la clase

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `configRecyclerView(android.support.v7.widget.RecyclerView recyclerView)` Metodo que se encarga de hacer una configuracion inicial del `RecyclerView` que muestra el listado de las ultimas 10 mediciones almacenadas en la Base de Datos.
    `void` | `onDeleteMeasurementClicked(java.lang.String nombre, java.lang.String fechaHora)` Evento `ClickListener` que se llama cuando el usuario ha pulsado sobre el boton para borrar la medicion en `UltimasMedicionesFragment`.
    `void` | `onDestroy()` Perform any final cleanup before an activity is destroyed.
    `void` | `setUpInitialSettings(android.support.v7.widget.Toolbar toolbar)` Metodo que realiza las operaciones iniciales cuando se crea el `Fragment UltimasMedicionesFragment`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### UltimasMedicionesPresenter

          public UltimasMedicionesPresenter(android.app.Fragment fragment,
                                            MainModel model)

      Constructor principal de la clase
      Parameters:
        `fragment` - Fragmento (Vista) con la que mantiene una relacion 1-a-1.
        `model` - Modelo (unico) de la aplicacion.

  - ### Method Detail

    - #### setUpInitialSettings

          public void setUpInitialSettings(android.support.v7.widget.Toolbar toolbar)

      Metodo que realiza las operaciones iniciales cuando se crea el `Fragment UltimasMedicionesFragment`.

      Se encarga de marcar el tercer item del `NavigationView` (correspondiente a `UltimasMedicionesFragment`), fijar la orientacion de la pantalla en "Portrait" y de utilizar el `Toolbar` recibido como `SupportActionBar`.

      Specified by:
        `setUpInitialSettings` in interface `PresenterFunctions.UltimasMedicionesFunctions`
      Parameters:
        `toolbar` - `Toolbar` a emplear como `SupportActionBar`

    - #### configRecyclerView

          public void configRecyclerView(android.support.v7.widget.RecyclerView recyclerView)

      Metodo que se encarga de hacer una configuracion inicial del `RecyclerView` que muestra el listado de las ultimas 10 mediciones almacenadas en la Base de Datos.

      Realiza una operacion para mejorar el rendimiento del mismo, asi como añadirle el `LayoutManager` y el `RecyclerView.Adapter`.

      Specified by:
        `configRecyclerView` in interface `PresenterFunctions.UltimasMedicionesFunctions`
      Parameters:
        `recyclerView` - `RecyclerView` a configurar

    - #### onDeleteMeasurementClicked

          public void onDeleteMeasurementClicked(java.lang.String nombre,
                                                 java.lang.String fechaHora)

      Evento `ClickListener` que se llama cuando el usuario ha pulsado sobre el boton para borrar la medicion en `UltimasMedicionesFragment`.

      Se encarga de crear un dialogo que envia a la Vista para que se lo muestre al usuario, con el fin de confirmar que quiere borrar la medicion seleccionada.

      Si el usuario confirma que desea eliminar la medicion, el metodo se encarga de mostrar el listado de las ultimas 10 mediciones almacenadas, actualizado con la medicion ya eliminada.

      Specified by:
        `onDeleteMeasurementClicked` in interface `PresenterFunctions.UltimasMedicionesFunctions`
      Parameters:
        `nombre` - Nombre del paciente al que se le realizo la medicion
        `fechaHora` - Fecha y hora en la que se realizo la medicion

    - #### onDestroy

          public void onDestroy()

      Perform any final cleanup before an activity is destroyed. Se encarga de liberar la referencia al `Fragment` con el que esta asociado.
      Specified by:
        `onDestroy` in interface `PresenterFunctions`